---
name: Bug Report
about: Report a bug with using rust-gpu.
title: '(my bug report)'
labels: 't: bug'
---

<!-- Thank you for filing a bug report! 🐛 -->

### Expected Behaviour
<!-- Please describe what you expected to happen. -->

### Example & Steps To Reproduce
<!-- 
Describe what actually happened, including any relevant examples (smaller
the better), error messages, or the relevant SPIR-V binary. 
-->

1.
2.
3.

## System Info
<!--
Helpful commands:
- Rustc version: `rustc -V`
- SPIR-V version: `spirv-val --version`
-->

 - Rust: [e.g. 1.49.0-nightly (1eaadebb3 2020-10-21)]
 - OS: [e.g. macOS 10.15.7]
 - GPU: [e.g. Intel(R) UHD Graphics 630]
 - SPIR-V: [e.g. v2020.3 unknown hash, 2020-06-12T01:06:18]


## Backtrace
<!-- If relevant, please include a backtrace of the error below. -->

<details><summary>Backtrace</summary>
<p>

```
<backtrace>
```

</p>
</details>
